<template>
  <FormControl
    :id="`${id}-datepicker`"
    :label="label"
    :required="required"
    :error="error"
  >
    <Datepicker
      v-show="!isPreview"
      class="c-datepicker"
      :id="id"
      :placeholder="placeholder"
      :required="required"
      minimum-view="month"
      :value="value"
      format="yyyy-MM"
      @input="setDate"
    />
    <Paragraph v-if="isPreview" :text="moment(value)" class="preview-text" />
  </FormControl>
</template>

<script>
import moment from "moment";
import Datepicker from "vuejs-datepicker";
import FormControl from "./FormControl";
import { isPreviewMixin } from "../../mixins/isPreview";
import Paragraph from "../Paragraph";

export default {
  name: "FormDatePicker",
  components: { Paragraph, FormControl, Datepicker },
  mixins: [isPreviewMixin],
  props: {
    id: {
      type: String,
      required: true
    },
    value: {
      type: [Date, String],
      required: true
    },
    label: String,
    error: String,
    placeholder: {
      type: String,
      default: "Choose"
    },
    required: {
      type: Boolean,
      default: true
    },
    model: {
      prop: "value",
      event: "input"
    }
  },
  methods: {
    setDate(value) {
      this.$emit("input", value);
    },
    moment(date) {
      return moment(date).format("YYYY-MM");
    }
  }
};
</script>

<style lang="scss">
.c-datepicker {
  input {
    cursor: pointer;
  }
  .vdp-datepicker__calendar {
    @include breakpoint(phone) {
      width: 100%;
    }
    .cell {
      font-size: 1.4rem;
      &.selected {
        color: $c-white;
        background-color: $c-brand-primary !important;
        border-color: $c-brand-primary !important;
      }

      &:hover {
        border-color: $c-brand-primary !important;
      }
    }
    .prev {
      &:after {
        border-right-color: $c-brand-primary;
      }
    }
    .next {
      &:after {
        border-left-color: $c-brand-primary;
      }
    }
    header {
      span {
        font-size: 1.4rem;
      }
    }
  }
}
</style>
